#! /usr/local/bin/ruby

require 'template.rb'

f = open('auto_funcs.inc', 'w')
d = open('auto_defs.inc', 'w')

open('api.def').each {|l|
  macro,type = l.split(/\t+/)
  macro.strip!
  macro.sub!(/CINIT[(]/, '').sub!(/[)],/, '')
  key = macro.split(',')[0]
  type = 'nil'  unless type
  type.strip!

  name = key.downcase
  id = "CURLOPT_#{key}"

  if Template[type]
    f.puts Template[type].gsub('<NAME>', name).gsub('<ID>', id)

    d.puts %!   rb_define_method(cCurl, "#{name}=", set_#{name}, 1);!
    d.puts %!   rb_define_attr(cCurl, "#{name}", 1,0);!
  end
}
